TinyXML-2: tinyxml2::XMLHandle Class Reference

TinyXML-2 10.0.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
tinyxml2::XMLHandle Class Reference

`#include <tinyxml2.h>`

## Public Member Functions
| XMLHandle (XMLNode *node)
| Create a handle from any node (at any depth of the tree.) This can be a null pointer.
| XMLHandle (XMLNode &node)
| Create a handle from a node.
| XMLHandle (const XMLHandle &ref)
| Copy constructor.
XMLHandle & | operator= (const XMLHandle &ref)
| Assignment.
XMLHandle | FirstChild ()
| Get the first child of this handle.
XMLHandle | FirstChildElement (const char *name=0)
| Get the first child element of this handle.
XMLHandle | LastChild ()
| Get the last child of this handle.
XMLHandle | LastChildElement (const char *name=0)
| Get the last child element of this handle.
XMLHandle | PreviousSibling ()
| Get the previous sibling of this handle.
XMLHandle | PreviousSiblingElement (const char *name=0)
| Get the previous sibling element of this handle.
XMLHandle | NextSibling ()
| Get the next sibling of this handle.
XMLHandle | NextSiblingElement (const char *name=0)
| Get the next sibling element of this handle.
XMLNode * | ToNode ()
| Safe cast to XMLNode. This can return null.
XMLElement * | ToElement ()
| Safe cast to XMLElement. This can return null.
XMLText * | ToText ()
| Safe cast to XMLText. This can return null.
XMLUnknown * | ToUnknown ()
| Safe cast to XMLUnknown. This can return null.
XMLDeclaration * | ToDeclaration ()
| Safe cast to XMLDeclaration. This can return null.

## Detailed Description

A XMLHandle is a class that wraps a node pointer with null checks; this is an incredibly useful thing. Note that XMLHandle is not part of the TinyXML-2 DOM structure. It is a separate utility class.

Take an example:

    <Document>
        <Element attributeA = "valueA">
            <Child attributeB = "value1" />
            <Child attributeB = "value2" />
        </Element>
    </Document>

Assuming you want the value of "attributeB" in the 2nd "Child" element, it's very easy to write a lot of code that looks like:

    XMLElement* root = document.FirstChildElement( "Document" );
    if ( root )
    {
        XMLElement* element = root->FirstChildElement( "Element" );
        if ( element )
        {
            XMLElement* child = element->FirstChildElement( "Child" );
            if ( child )
            {
                XMLElement* child2 = child->NextSiblingElement( "Child" );
                if ( child2 )
                {
                    // Finally do something useful.

And that doesn't even cover "else" cases. XMLHandle addresses the verbosity of such code. A XMLHandle checks for null pointers so it is perfectly safe and correct to use:

    XMLHandle docHandle( &document );
    XMLElement* child2 = docHandle.FirstChildElement( "Document" ).FirstChildElement( "Element" ).FirstChildElement().NextSiblingElement();
    if ( child2 )
    {
        // do something useful

Which is MUCH more concise and useful.

It is also safe to copy handles - internally they are nothing more than node pointers.

    XMLHandle handleCopy = handle;

See also XMLConstHandle, which is the same as XMLHandle, but operates on const objects.

The documentation for this class was generated from the following file:

- tinyxml2.h